//isr.asm
.include GPL951_Body.inc


.TEXT


.public _BREAK;

.public _FIQ;

.public _IRQ0;

.public _IRQ1;

.public _IRQ2;

.public _IRQ3;

.public _IRQ4;

.public _IRQ5;

.public _IRQ6;

.public _IRQ7;


.external	_USB_Insert_TimeOut
.external 	_USB_ISR
.external 	_CDROMTimerOccur
.external   _USB_Insert_TimeOut

//------------------------------------------------------------------------------

_BREAK:
	    push    r1,bp to [sp];
	    //add your code here
	    pop     r1,bp from [sp]
	    reti
_FIQ:
	    push    r1,bp to [sp];
	    //add your code here
	
	    pop     r1,bp from [sp]
	    reti
_IRQ0:
	    push    r1,bp to [sp];
	    //add your code here
	    pop     r1,bp from [sp]
	    reti
_IRQ1:
	    push    r1,bp to [sp];
	    //add your code here
	    pop     r1,bp from [sp]
	    reti
_IRQ2:
	    push    r1,bp to [sp];
	    //add your code here
	    pop     r1,bp from [sp]
	    reti
_IRQ3:
	    
	    push r1,r5 to [sp]
		
		r1=[P_INT_Status1]
		test r1,C_INT_USB_IF
		jz ?END
		
		call _USB_ISR
	?END:	
		pop r1,r5 from [sp]
		reti
		
_IRQ4:
	    
	    push r1,r5 to [sp]
	    
		r1=[P_INT_Status3]
		test r1,C_INT_TMD_IF
		jz ?L_INT_TimerA
	
		[P_INT_Status3] = r1
		call _CDROMTimerOccur		// use when USB CDRom enable, if you not use CDROM function, you can mask it.
		jmp  ?L_IRQ4END	
	?L_INT_TimerA:
		r1=[P_INT_Status3]
		test r1,C_INT_TMA_IF
		call _USB_Insert_TimeOut	
		jz ?L_IRQ4END	
	
	?L_IRQ4END:
			
		pop r1,r5 from [sp]
		reti
_IRQ5:
	    push    r1,bp to [sp];
	    //add your code here
	    pop     r1,bp from [sp]
	    reti
_IRQ6:
	    push    r1,bp to [sp];
	    //add your code here
	    pop     r1,bp from [sp]
	    reti
_IRQ7:
	    push    r1,bp to [sp];
	    //add your code here
	    pop     r1,bp from [sp]
	    reti
